Index: /ruby/trunk/adl_parser/lib/parser.y
===================================================================
--- /ruby/trunk/adl_parser/lib/parser.y	(revision 30)
+++ /ruby/trunk/adl_parser/lib/parser.y	(revision 20)
@@ -28,75 +28,30 @@
 
 input: archetype EOF
-  { 
-    result = val[0]
-  }
   | error
 
-archetype: arch_identification arch_specialisation arch_concept arch_language arch_description arch_definition arch_invariant arch_ontology
-  { 
-    assert_at(__FILE__,__LINE__) do
-      val[4].instance_of?(OpenEHR::AM::Archetype::Archetype_Description::ARCHETYPE_DESCRIPTION) and val[5].instance_of?(OpenEHR::AM::Archetype::Constraint_Model::C_COMPLEX_OBJECT) and val[7].instance_of?(OpenEHR::AM::Archetype::Ontology::ARCHETYPE_ONTOLOGY) 
-    end
-    
-    archetype_id = val[0][:archetype_id]
-    adl_version = val[0][:arch_head][:arch_meta_data][:adl_version]
-    concept = val[2]
-    language = val[3][:arch_language]
-    archetype = OpenEHR::AM::Archetype::ARCHETYPE.create(
-                                                         :archetype_id => archetype_id,
-                                                         :adl_version => adl_version,
-                                                         :concept => concept,
-                                                         :description => val[4],
-                                                         :definition => val[5],
-                                                         :ontology => val[7]
-                                                         ) do |archetype|
-      archetype.original_language = language
-    end
-    @@log.info("#{__FILE__}:#{__LINE__}: archetype = #{archetype} at #{@filename}:#{@lineno}")
-    result = archetype
-  }
+archetype: arch_identification
+  arch_specialisation
+  arch_concept
+  arch_language
+  arch_description
+  arch_definition
+  arch_invariant
+  arch_ontology
 
 
 arch_identification: arch_head V_ARCHETYPE_ID
-  { 
-    result = {:arch_head => val[0], :archetype_id => val[1] }
-  }
   | SYM_ARCHETYPE error
-  { 
-    raise
-  }
 
 arch_head: SYM_ARCHETYPE
-  { 
-    result = {:arch_meta_data => nil }
-  }
   | SYM_ARCHETYPE arch_meta_data
-  { 
-    result = val[1]
-  }
 
 arch_meta_data: Left_parenthesis_code arch_meta_data_items Right_parenthesis_code
-  { 
-    result = {:arch_meta_data => val[1] }
-  }
 
 arch_meta_data_items: arch_meta_data_item
-  { 
-    result = val[0]
-  }
   | arch_meta_data_items Semicolon_code arch_meta_data_item
-  { 
-    result = val[0].merge(val[2])
-  }
-
+#  | arch_meta_data_items ';' arch_meta_data_item
 
 arch_meta_data_item: SYM_ADL_VERSION SYM_EQ V_VERSION_STRING
-  { 
-    result = {:adl_version => val[2], :is_controlled => false }
-  }
   | SYM_IS_CONTROLLED
-  { 
-    result = {:is_controlled => true }
-  }
 
 # Define specialization in which its constraints are narrower than those of the parent.
@@ -107,7 +62,4 @@
 
 arch_concept: SYM_CONCEPT V_LOCAL_TERM_CODE_REF
-  { 
-    result = {:arch_concept => val[1] }
-  }
   | SYM_CONCEPT error
 
@@ -117,10 +69,7 @@
 
 arch_language: #-- empty is ok for ADL 1.4 tools
-  {
-    result = {:arch_language => nil}
-  }
     | SYM_LANGUAGE dadl_section
   {
-    result = {:arch_language => val[1]}
+    result = {:language => val[1]}
   }
   | SYM_LANGUAGE error
@@ -132,15 +81,9 @@
 arch_description: #-- no meta-data ok
     | SYM_DESCRIPTION dadl_section
-  { 
-    result = OpenEHR::AM::Archetype::Archetype_Description::ARCHETYPE_DESCRIPTION.new(:details => val[1])
-  }
-  | SYM_DESCRIPTION error
-  
+    | SYM_DESCRIPTION error
+
 #arch_definition: SYM_DEFINITION V_CADL_TEXT
 #  | SYM_DEFINITION error
 arch_definition: SYM_DEFINITION cadl_section
-  { 
-    result = val[1]
-  }
   | SYM_DEFINITION error
 
@@ -148,54 +91,30 @@
 ### cADL section
 cadl_section: c_complex_object
-  { 
-    assert_at(__FILE__,__LINE__){val[0].instance_of?(OpenEHR::AM::Archetype::Constraint_Model::C_COMPLEX_OBJECT)}
-    @@log.info("#{__FILE__}:#{__LINE__}: c_complex_object = #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
-  }
   | assertions
-  { 
-    result = val[0]
-  }
 #  | error
 
 #c_complex_object: c_complex_object_head SYM_MATCHES SYM_START_CBLOCK c_complex_object_body SYM_END_CBLOCK
 c_complex_object: c_complex_object_head SYM_MATCHES START_REGEXP_BLOCK REGEXP_BODY END_REGEXP_BLOCK # added by akimichi
-  { 
-    result = OpenEHR::AM::Archetype::Constraint_Model::C_COMPLEX_OBJECT.create(:attributes => val[3]) do |c_complex_object|
-      c_complex_object.node_id = val[0][:c_complex_object_id][:local_term_code_ref]
-      c_complex_object.rm_type_name = val[0][:c_complex_object_id][:type_identifier]
-      c_complex_object.occurrences = val[0][:c_occurrences]
-    end
-  }
     | c_complex_object_head SYM_MATCHES SYM_START_CBLOCK c_complex_object_body SYM_END_CBLOCK
-  { 
-    result = OpenEHR::AM::Archetype::Constraint_Model::C_COMPLEX_OBJECT.create(:attributes => val[3]) do |c_complex_object|
-      c_complex_object.node_id = val[0][:c_complex_object_id][:local_term_code_ref]
-      c_complex_object.rm_type_name = val[0][:c_complex_object_id][:type_identifier]
-      c_complex_object.occurrences = val[0][:c_occurrences]
-    end
-  }
-#    | c_complex_object_head error SYM_END_CBLOCK
+#     | c_complex_object_head error SYM_END_CBLOCK
+#   {
+#     @adl_type.push(:cadl)
+#     yyerror
+#   }
 #    | c_complex_object_head SYM_MATCHES SYM_START_CBLOCK c_complex_object_body c_invariants SYM_END_CBLOCK
 
 c_complex_object_head: c_complex_object_id c_occurrences
-  {
-    result = {:c_complex_object_id => val[0], :c_occurrences => val[1]}
-  }
 
 c_complex_object_id: type_identifier
   {
-    result = {:type_identifier => val[0]}
+    result = {:c_complex_object_id => {:type_identifier => val[0]}}
   }
   | type_identifier V_LOCAL_TERM_CODE_REF
   {
-    result = {:type_identifier => val[0], :local_term_code_ref => val[1]}
+    result = {:c_complex_object_id => {:type_identifier => val[0], :V_LOCAL_TERM_CODE_REF => val[1]}}
   }
 
 c_complex_object_body: c_any #-- used to indicate that any value of a type is ok
   | c_attributes
-  { 
-    result = OpenEHR::AM::Archetype::Constraint_Model::C_COMPLEX_OBJECT.new(:attributes => val[0])
-  }
 
 
@@ -203,35 +122,11 @@
 
 c_object: v_c_domain_type
-  { 
-    result = val[0]
-  }
   | c_complex_object
-  { 
-    result = OpenEHR::AM::Archetype::Constraint_Model::C_COMPLEX_OBJECT.new
-  }
   | archetype_internal_ref
-  { 
-    result = OpenEHR::AM::Archetype::Constraint_Model::ARCHETYPE_INTERNAL_REF.new
-  }
   | archetype_slot
-  { 
-    result = OpenEHR::AM::Archetype::Constraint_Model::ARCHETYPE_SLOT.new
-  }
   | constraint_ref
-  { 
-    result = OpenEHR::AM::Archetype::Constraint_Model::CONSTRAINT_REF.new
-  }
   | c_code_phrase
-  { 
-    result = val[0]
-  }
   | c_ordinal
-  { 
-    result = val[0]
-  }
   | c_primitive_object
-  { 
-    result = val[0]
-  }
 #  | v_c_domain_type
 #  | V_C_DOMAIN_TYPE
@@ -246,7 +141,4 @@
 
 v_c_domain_type: START_V_C_DOMAIN_TYPE_BLOCK dadl_section END_V_C_DOMAIN_TYPE_BLOCK
-  { 
-    result = val[1]
-  }
 
 # 'archetype_internal_ref' is a node that refers to a previously defined object node in the same archetype.
@@ -265,50 +157,13 @@
 # 'c_primitive_object' is an node representing a constraint on a primitive object type.
 c_primitive_object: c_primitive
-  {
-    assert_at(__FILE__,__LINE__){val[0].kind_of?(OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_PRIMITIVE)}
-    result = OpenEHR::AM::Archetype::Constraint_Model::C_PRIMITIVE_OBJECT.new(:item => val[0])
-  }
 
 c_primitive: c_integer
-  {
-    @@log.info("#{__FILE__}:#{__LINE__}: c_integer = #{val[0]} at #{@filename}:#{@lineno}")
-    result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_INTEGER.new
-  }
   | c_real
-  {
-    @@log.info("#{__FILE__}:#{__LINE__}: c_real = #{val[0]} at #{@filename}:#{@lineno}")
-    result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_REAL.new
-  }
   | c_date
-  {
-    @@log.info("#{__FILE__}:#{__LINE__}: c_date = #{val[0]} at #{@filename}:#{@lineno}")
-    result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_DATE.new
-  }
   | c_time
-  {
-    @@log.info("#{__FILE__}:#{__LINE__}: c_time = #{val[0]} at #{@filename}:#{@lineno}")
-    result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_TIME.new
-  }
   | c_date_time
-  {
-    @@log.info("#{__FILE__}:#{__LINE__}: c_date_time = #{val[0]} at #{@filename}:#{@lineno}")
-    result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_DATE_TIME.new
-  }
   | c_duration
-  {
-    @@log.info("#{__FILE__}:#{__LINE__}: c_duration = #{val[0]} at #{@filename}:#{@lineno}")
-    result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_DURATION.new
-  }
   | c_string
-  {
-    @@log.info("#{__FILE__}:#{__LINE__}: c_string = #{val[0]} at #{@filename}:#{@lineno}")
-    result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_STRING.new
-  }
   | c_boolean
-  {
-    assert_at(__FILE__,__LINE__){val[0].instance_of?(OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_BOOLEAN)}
-    @@log.info("#{__FILE__}:#{__LINE__}: c_boolean = #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
-  }
 
 c_any: Star_code
@@ -318,30 +173,10 @@
 
 c_attributes: c_attribute
-  { 
-    result = [val[0]]
-  }
   | c_attributes c_attribute
-  { 
-    result = (val[0] << val[1])
-  }
 
 # 'c_attribute' is a node representing a constraint on an attribute in an object model.
 c_attribute: c_attr_head SYM_MATCHES SYM_START_CBLOCK c_attr_values SYM_END_CBLOCK
-  { 
-    assert_at(__FILE__,__LINE__){ val[0].kind_of?(OpenEHR::AM::Archetype::Constraint_Model::C_ATTRIBUTE)}
-    c_attribute = val[0]
-    c_attribute.children = val[3]
-    result = c_attribute
-  }
   | c_attr_head SYM_MATCHES START_REGEXP_BLOCK REGEXP_BODY END_REGEXP_BLOCK # added by akimichi
-  { 
-    assert_at(__FILE__,__LINE__){ val[0].kind_of?(OpenEHR::AM::Archetype::Constraint_Model::C_ATTRIBUTE)}
-    result = val[0]
-  }
   | c_attr_head SYM_MATCHES SYM_START_CBLOCK error SYM_END_CBLOCK
-  { 
-    assert_at(__FILE__,__LINE__){ val[0].kind_of?(OpenEHR::AM::Archetype::Constraint_Model::C_ATTRIBUTE)}
-    result = val[0]
-  }
 
 
@@ -349,33 +184,13 @@
   {
     @@log.info("#{__FILE__}:#{__LINE__}: V_ATTRIBUTE_IDENTIFIER = #{val[0]}, c_existence = #{val[1]} at #{@filename}")
-    result = OpenEHR::AM::Archetype::Constraint_Model::C_SINGLE_ATTRIBUTE.new(
-                                                                              :rm_attribute_name => val[0],
-                                                                              :existence => val[1]
-                                                                              )
-
   }
   | V_ATTRIBUTE_IDENTIFIER c_existence c_cardinality
   {
-    assert_at(__FILE__,__LINE__){ val[2].instance_of?(OpenEHR::AM::Archetype::Constraint_Model::CARDINALITY) }
     @@log.info("#{__FILE__}:#{__LINE__}: V_ATTRIBUTE_IDENTIFIER: #{val[0]}, c_existence = #{val[1]}, c_cardinality = #{val[2]} at #{@filename}") 
-    result = OpenEHR::AM::Archetype::Constraint_Model::C_MULTIPLE_ATTRIBUTE.new(
-                                                                                :rm_attribute_name => val[0],
-                                                                                :existence => val[1],
-                                                                                :cardinality => val[2]
-                                                                                )
   }
 
 c_attr_values: c_object
-  { 
-    result = Array[val[0]]
-  }
   | c_attr_values c_object
-  { 
-    result = (val[0] << val[1])
-  }
   | c_any #	-- to allow a property to have any value
-  { 
-    result = Array[val[0]]
-  }
 
 ### c_includes: #-- Empty
@@ -405,8 +220,4 @@
 
 arch_ontology: SYM_ONTOLOGY dadl_section
-  { 
-    dadl_section = val[1]
-    result = OpenEHR::AM::Archetype::Ontology::ARCHETYPE_ONTOLOGY.new
-  }
   | SYM_ONTOLOGY error
 
@@ -420,20 +231,11 @@
 
 attr_vals: attr_val
-  {
-    result = Array[val[0]]
-  }
   | attr_vals attr_val
-  {
-    result = (val[0] << val[1])
-  }
   | attr_vals Semicolon_code attr_val
-  {
-    result = (val[0] << val[2])
-  }
+#  | attr_vals ';' attr_val
 
 attr_val: attr_id SYM_EQ object_block
   {
     @@log.info("#{__FILE__}:#{__LINE__}: attr_id = #{val[0]}, object_block = #{val[2]} at #{@filename}:#{@lineno}")
-    result = {:attr_id => val[0], :object_block => val[2]}
   }
 
@@ -441,59 +243,29 @@
   {
     @@log.info("#{__FILE__}:#{__LINE__}: V_ATTRIBUTE_IDENTIFIER = #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
   }
   | V_ATTRIBUTE_IDENTIFIER error
 
 object_block: complex_object_block
-  { 
-    result = val[0]
-  }
   | primitive_object_block
-  { 
-    result = val[0]
-  }
 
 complex_object_block: single_attr_object_block
-  { 
-    result = val[0]
-  }
   | multiple_attr_object_block
-  { 
-    result = val[0]
-  }
 
 multiple_attr_object_block: untyped_multiple_attr_object_block
-  { 
-    result = {:untyped_multiple_attr_object_block => val[0]}
-  }
   | type_identifier untyped_multiple_attr_object_block
-  { 
-    result = {:type_identifier => val[0], :untyped_multiple_attr_object_block => val[1]}
-  }
 
 untyped_multiple_attr_object_block: multiple_attr_object_block_head keyed_objects SYM_END_DBLOCK
-  { 
-    result = {:multiple_attr_object_block_head => val[0], :keyed_objects => val[1]}
-  }
 
 multiple_attr_object_block_head: SYM_START_DBLOCK
-  { 
+  {
     @@log.info("SYM_START_DBLOCK: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
   }
 
 keyed_objects: keyed_object
-  { 
-    result = Array[val[0]]
-  }
   | keyed_objects keyed_object
-  { 
-    result = (val[0] << val[1])
-  }
 
 keyed_object: object_key SYM_EQ object_block
   {
     @@log.info("#{__FILE__}:#{__LINE__}: keyed_object = #{val[0]}, object_block = #{val[2]} at #{@filename}:#{@lineno}")
-    result = {:object_key => val[0], :object_block => val[1]}
   }
 
@@ -501,113 +273,62 @@
   {
     @@log.info("object_key: [#{val[1]}] at #{@filename}:#{@lineno}")
-    result = val[1]
   }
 
 single_attr_object_block: untyped_single_attr_object_block
-  {
-    result = {:untyped_single_attr_object_block => val[0]}
-  }
   | type_identifier untyped_single_attr_object_block
-  {
-    result = {:type_identifier => val[0], :untyped_single_attr_object_block => val[1]}
-  }
-
 untyped_single_attr_object_block: single_attr_object_complex_head SYM_END_DBLOCK # <>
-  {
-    @@log.info("#{__FILE__}:#{__LINE__}: single_attr_object_complex_head = #{val[0]} at #{@filename}:#{@lineno}")
-    result = {:single_attr_object_complex_head => val[0]}
-  }
   | single_attr_object_complex_head attr_vals SYM_END_DBLOCK
-  {
-    @@log.info("#{__FILE__}:#{__LINE__}: single_attr_object_complex_head = #{val[0]}, attr_vals = #{val[1]} at #{@filename}:#{@lineno}")
-    result = {:single_attr_object_complex_head => val[0], :attr_vals => val[1]}
-  }
 single_attr_object_complex_head: SYM_START_DBLOCK
 primitive_object_block: untyped_primitive_object_block
-  {
-    @@log.info("#{__FILE__}:#{__LINE__}: untyped_primitive_object_block = #{val[0]} at #{@filename}:#{@lineno}")
-    result = {:untyped_primitive_object_block => val[0]}
-  }
   | type_identifier untyped_primitive_object_block
-  {
-    @@log.info("#{__FILE__}:#{__LINE__}: type_identifier = #{val[0]}, untyped_primitive_object_block = #{val[1]} at #{@filename}:#{@lineno}")
-    result = {:type_identifier => val[0], :untyped_primitive_object_block => val[1]}
-  }
 untyped_primitive_object_block: SYM_START_DBLOCK primitive_object_value SYM_END_DBLOCK
   {
-    @@log.info("#{__FILE__}:#{__LINE__}: primitive_object_block = <#{val[1]}> at #{@filename}:#{@lineno}")
-    result = val[1]
+    @@log.info("#{__FILE__}:#{__LINE__}: primitive_object_block = <#{val[2]}> at #{@filename}:#{@lineno}")
   }
 primitive_object_value: simple_value
-  {
-    result = val[0]
-  }
   | simple_list_value
-  {
-    result = val[0]
-  }
   | simple_interval_value
-  {
-    result = val[0]
-  }
   | term_code
-  {
-    result = val[0]
-  }
   | term_code_list_value
-  {
-    result = val[0]
-  }
 simple_value: string_value
   {
     @@log.info("string_value: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
   }
   | integer_value
   {
     @@log.info("integer_value: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
   }
   | real_value
   {
     @@log.info("real_value: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
   }
   | boolean_value
   {
     @@log.info("boolean_value: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
   }
   | character_value
   {
     @@log.info("character_value: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
   }
   | date_value
   {
     @@log.info("date_value: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
   }
   | time_value
   {
     @@log.info("time_value: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
   }
   | date_time_value
   {
     @@log.info("date_time_value: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
   }
   | duration_value
   {
     @@log.info("duration_value: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
   }
   | uri_value
   {
     @@log.info("uri_value: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
-  }
-
+  }
 simple_list_value: string_list_value
   | integer_list_value
@@ -630,10 +351,8 @@
   {
     @@log.info("V_TYPE_IDENTIFIER: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
   }
   | V_GENERIC_TYPE_IDENTIFIER
   {
     @@log.info("V_GENERIC_TYPE_IDENTIFIER: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
   }
 
@@ -641,5 +360,4 @@
   {
     @@log.info("V_STRING: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
   }
 
@@ -649,30 +367,6 @@
 
 integer_value: V_INTEGER
-  { 
-    begin
-      integer = Integer(val[0])
-    rescue
-      raise
-    end
-    result = integer
-  }
   | Plus_code V_INTEGER
-  {
-    begin
-      integer = Integer(val[0])
-    rescue
-      raise
-    end
-    result = integer
-  }
   | Minus_code V_INTEGER
-  {
-    begin
-      integer = Integer(val[0])
-    rescue
-      raise
-    end
-    result = - integer
-  }
 ###   | '+' V_INTEGER
 ###   | '-' V_INTEGER
@@ -693,30 +387,8 @@
 
 real_value: V_REAL
-  {
-    begin
-      real = Float(val[0])
-    rescue
-      raise
-    end
-    result = real
-  }
   | Plus_code V_REAL
-  {
-    begin
-      real = Float(val[1])
-    rescue
-      raise
-    end
-    result = real
-  }
   | Minus_code V_REAL
-  {
-    begin
-      real = Float(val[1])
-    rescue
-      raise
-    end
-    result = - real
-  }
+#  | '+' V_REAL
+#  | '-' V_REAL
 
 real_list_value: real_value Comma_code real_value
@@ -736,11 +408,5 @@
 
 boolean_value: SYM_TRUE
-  { 
-    result = true
-  }
   | SYM_FALSE
-  { 
-    result = false
-  }
 
 boolean_list_value: boolean_value Comma_code boolean_value
@@ -805,5 +471,4 @@
   {
     @@log.info("V_ISO8601_DURATION: #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
   }
 
@@ -825,5 +490,4 @@
   {
     @@log.info("#{__FILE__}:#{__LINE__}: V_QUALIFIED_TERM_CODE_REF = #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
   }
 
@@ -835,5 +499,4 @@
   {
     @@log.info("#{__FILE__}:#{__LINE__}: V_URI = #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
   }
 
@@ -918,36 +581,10 @@
 
 c_existence: #-- default to 1..1
-    { 
-    result = Range.new(1,1)
-  }
-  | SYM_EXISTENCE SYM_MATCHES SYM_START_CBLOCK existence_spec SYM_END_CBLOCK
-  { 
-    result = val[3]
-  }
+    | SYM_EXISTENCE SYM_MATCHES SYM_START_CBLOCK existence_spec SYM_END_CBLOCK
 
 existence_spec:  V_INTEGER #-- can only be 0 or 1
-  { 
-    begin
-      integer = Integer(val[0])
-    rescue
-      raise
-    end
-    result = integer
-  }
   | V_INTEGER SYM_ELLIPSIS V_INTEGER #-- can only be 0..0, 0..1, 1..1
-  { 
-    begin
-      from_integer = Integer(val[0])
-      to_integer = Integer(val[2])
-    rescue
-      raise
-    end
-    result = Range.new(from_integer,to_integer)
-  }
 
 c_cardinality: SYM_CARDINALITY SYM_MATCHES SYM_START_CBLOCK cardinality_spec SYM_END_CBLOCK
-  { 
-    result = OpenEHR::AM::Archetype::Constraint_Model::CARDINALITY.new
-  }
 
 cardinality_spec: occurrence_spec
@@ -966,7 +603,4 @@
 c_occurrences:  #-- default to 1..1
   | SYM_OCCURRENCES SYM_MATCHES SYM_START_CBLOCK occurrence_spec SYM_END_CBLOCK
-  { 
-    result = val[3]
-  }
   | SYM_OCCURRENCES error
 
@@ -1036,39 +670,21 @@
 
 c_boolean_spec: SYM_TRUE
-  { 
-    result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_BOOLEAN.new(:true_valid => true)
-  }
   | SYM_FALSE
-  { 
-    result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_BOOLEAN.new(:true_valid => false)
-  }
   | SYM_TRUE Comma_code SYM_FALSE
-  { 
-    result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_BOOLEAN.new(:true_valid => true,:false_valid => false)
-  }
   | SYM_FALSE Comma_code SYM_TRUE
-  { 
-    result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_BOOLEAN.new(:true_valid => false,:false_valid => true)
-  }
 
 c_boolean: c_boolean_spec
-  { 
-    result = val[0]
-  }
   | c_boolean_spec Semicolon_code boolean_value
-  {
-    raise 'Not implemented yet'
-  }
   | c_boolean_spec Semicolon_code error
-  {
-    raise 'Not implemented yet'
-  }
+#  | c_boolean_spec ';' error
 
 c_ordinal: c_ordinal_spec
   | c_ordinal_spec Semicolon_code integer_value
   | c_ordinal_spec Semicolon_code error
+#  | c_ordinal_spec ';' error
 
 c_ordinal_spec: ordinal
   | c_ordinal_spec Comma_code ordinal
+#  | c_ordinal_spec ',' ordinal
 
 ordinal: integer_value SYM_INTERVAL_DELIM V_QUALIFIED_TERM_CODE_REF
@@ -1106,7 +722,4 @@
 
 duration_pattern: V_ISO8601_DURATION_CONSTRAINT_PATTERN
-  { 
-    result = val[0]
-  }
 
 
@@ -1118,6 +731,5 @@
 require 'lib/util.rb'
 require 'lib/scanner.rb'
-require 'rubygems'
-require 'am.rb'
+require 'lib/model.rb'
 $DEBUG = true
 
@@ -1125,10 +737,4 @@
 
 ---- inner
-
-def assert_at(file,line, message = "")
-  unless yield
-    raise "Assertion failed !: #{file}, #{line}: #{message}"
-  end
-end
 
 @@log = Logger.new('log/parser.log','daily')
Index: /ruby/trunk/adl_parser/lib/scanner.rb
===================================================================
--- /ruby/trunk/adl_parser/lib/scanner.rb	(revision 30)
+++ /ruby/trunk/adl_parser/lib/scanner.rb	(revision 20)
@@ -115,5 +115,7 @@
               Yaparc::Apply.new(
                                 Yaparc::Alt.new(Yaparc::Regex.new(/\AP([0-9]+|[yY])?([0-9]+|[mM])?([0-9]+|[wW])?([0-9]+|[dD])?T([0-9]+|[hH])?([0-9]+|[mM])?([0-9]+|[sS])?/),
-                                                Yaparc::Regex.new(/\AP([0-9]+|[yY])?([0-9]+|[mM])?([0-9]+|[wW])?([0-9]+|[dD])?/))) do |match|
+                                                Yaparc::Regex.new(/AP([0-9]+|[yY])?([0-9]+|[mM])?([0-9]+|[wW])?([0-9]+|[dD])?/))) do |match|
+#                                 Yaparc::Alt.new(Yaparc::Regex.new(/\AP([0-9]+[yY])?([0-9]+[mM])?([0-9]+[wW])?([0-9]+[dD])?T([0-9]+[hH])?([0-9]+[mM])?([0-9]+[sS])?/),
+#                                                 Yaparc::Regex.new(/AP([0-9]+[yY])?([0-9]+[mM])?([0-9]+[wW])?([0-9]+[dD])?/))) do |match|
                 LOG.info("V_ISO8601_DURATION: #{match}")
                 [:V_ISO8601_DURATION, match]
@@ -158,7 +160,5 @@
             @parser = lambda do |input|
               reserved_parsers = OpenEHR::ADL::Scanner::DADL::RESERVED.map do |keyword| 
-                Yaparc::Tokenize.new(
-                                     Yaparc::Literal.new(keyword[0], false)
-                                     )
+                Yaparc::Tokenize.new(Yaparc::Literal.new(keyword[0], false))
               end
               Yaparc::Alt.new(Yaparc::Apply.new(Yaparc::Alt.new(*reserved_parsers)) do |match|
@@ -248,18 +248,4 @@
         end
 
-        #V_ISO8601_DURATION_CONSTRAINT_PATTERN 
-        class V_ISO8601_DURATION_CONSTRAINT_PATTERN
-          include Yaparc::Parsable
-          def initialize
-            @parser = lambda do |input|
-              Yaparc::Apply.new(Yaparc::Alt.new(Yaparc::Regex.new(/\AP[yY]?[mM]?[wW]?[dD]?T[hH]?[mM]?[sS]?/),
-                                                Yaparc::Regex.new(/\AP[yY]?[mM]?[wW]?[dD]?/))) do |match|
-                OpenEHR::ADL::Scanner::Common::LOG.info("V_ISO8601_DURATION_CONSTRAINT_PATTERN: #{match}")
-                [:V_ISO8601_DURATION_CONSTRAINT_PATTERN, match]
-              end
-            end
-          end
-        end
-
         #V_C_DOMAIN_TYPE /\A[A-Z][a-zA-Z0-9_]*[ \n]*\</
         class V_C_DOMAIN_TYPE
@@ -284,5 +270,4 @@
                               OpenEHR::ADL::Scanner::Common::V_ISO8601_DURATION.new,
                               V_C_DOMAIN_TYPE.new,
-                              V_ISO8601_DURATION_CONSTRAINT_PATTERN.new,
                               Reserved.new,
                               OpenEHR::ADL::Scanner::Common::V_QUALIFIED_TERM_CODE_REF.new,
Index: /ruby/trunk/adl_parser/tests/cparser_test.rb
===================================================================
--- /ruby/trunk/adl_parser/tests/cparser_test.rb	(revision 20)
+++ /ruby/trunk/adl_parser/tests/cparser_test.rb	(revision 20)
@@ -0,0 +1,22 @@
+#$:.unshift File.join(File.dirname(__FILE__))
+
+require 'lib/cparser.rb'
+require 'test/unit'
+
+class CADLParserTest < Test::Unit::TestCase
+  def setup
+    @parser = ::OpenEHR::CADLParser.new
+  end
+
+  def test_init
+    assert_instance_of ::OpenEHR::CADLParser,@parser
+  end
+
+  def test_parse
+    vital_signs = File.read('tests/vital_signs.cadl')
+    assert_nothing_raised do
+      @parser.parse(vital_signs, 'vital_signs')
+    end
+  end
+
+end
Index: /ruby/trunk/adl_parser/tests/parser_test.rb
===================================================================
--- /ruby/trunk/adl_parser/tests/parser_test.rb	(revision 30)
+++ /ruby/trunk/adl_parser/tests/parser_test.rb	(revision 20)
@@ -1,2 +1,4 @@
+#$:.unshift File.join(File.dirname(__FILE__))
+
 require 'lib/parser.rb'
 require 'test/unit'
@@ -14,9 +16,5 @@
     laboratory_request = File.read('tests/openEHR-EHR-ITEM_TREE.Laboratory_request.v1.adl')
     assert_nothing_raised do
-      result = @parser.parse(laboratory_request, 'openEHR-EHR-ITEM_TREE.Laboratory_request.v1.adl')
-      assert_instance_of OpenEHR::AM::Archetype::ARCHETYPE, result
-      assert_instance_of OpenEHR::AM::Archetype::Archetype_Description::ARCHETYPE_DESCRIPTION, result.description
-      assert_instance_of OpenEHR::AM::Archetype::Constraint_Model::C_COMPLEX_OBJECT, result.definition
-#      assert_equal '', result.definition
+      @parser.parse(laboratory_request, 'openEHR-EHR-ITEM_TREE.Laboratory_request.v1.adl')
     end
 
@@ -24,7 +22,5 @@
     assert_nothing_raised do
       result = @parser.parse(apgar, 'openEHR-EHR-OBSERVATION.apgar.v1.adl')
-      assert_instance_of OpenEHR::AM::Archetype::ARCHETYPE, result
-      assert_instance_of OpenEHR::AM::Archetype::Archetype_Description::ARCHETYPE_DESCRIPTION, result.description
-      assert_instance_of OpenEHR::AM::Archetype::Constraint_Model::C_COMPLEX_OBJECT, result.definition
+      #       assert_equal "", result
     end
 
@@ -35,4 +31,8 @@
 
 
+#     medication = File.read('tests/openEHR-EHR-ITEM_TREE.medication.v1.adl')
+#     assert_nothing_raised do
+#       @parser.parse(medication, 'openEHR-EHR-ITEM_TREE.medication.v1.adl')
+#     end
 
     referral = File.read('tests/openEHR-EHR-ITEM_TREE.referral.v1.adl')
@@ -144,8 +144,4 @@
 
 
-#     medication = File.read('tests/openEHR-EHR-ITEM_TREE.medication.v1.adl')
-#     assert_nothing_raised do
-#       @parser.parse(medication, 'openEHR-EHR-ITEM_TREE.medication.v1.adl')
-#     end
   end
 end
Index: /ruby/trunk/adl_parser/tests/test_parser.rb
===================================================================
--- /ruby/trunk/adl_parser/tests/test_parser.rb	(revision 20)
+++ /ruby/trunk/adl_parser/tests/test_parser.rb	(revision 20)
@@ -0,0 +1,21 @@
+#$:.unshift File.join(File.dirname(__FILE__))
+
+require 'lib/parser.rb'
+require 'test/unit'
+
+class ADLParserTest < Test::Unit::TestCase
+  def setup
+    @parser = ::OpenEHR::ADL::Parser.new
+  end
+
+  def test_init
+    assert_instance_of ::OpenEHR::ADL::Parser,@parser
+  end
+
+  def test_parse
+    exam_uterine_cervix = File.read('tests/openEHR-EHR-CLUSTER.exam-uterine_cervix.v1.adl')
+    assert_nothing_raised do
+      @parser.parse(exam_uterine_cervix, 'openEHR-EHR-CLUSTER.exam-uterine_cervix.v1.adl')
+    end
+  end
+end
Index: /ruby/trunk/models/Rakefile
===================================================================
--- /ruby/trunk/models/Rakefile	(revision 30)
+++ /ruby/trunk/models/Rakefile	(revision 20)
@@ -34,32 +34,4 @@
 
 
-gem_spec = Gem::Specification.new do |s|
-  s.name = 'openehr_models'
-  s.author = 'Shinji KOBAYASHI, Akimichi TATSUKAWA'
-  s.version = '0.0.1'
-  s.summary = 'OpenEHR models'
-  s.email = 'openehr-jp@openehr.jp'
-  s.test_files = FileList['tests/test_*.rb', '*.adl']
-  candidates = Dir.glob("{am,rm,docs,tests}/**/*") + FileList['COPYING', 'Rakefile','am.rb','assumed_library_types.rb','rm.rb']
-  s.files = candidates.delete_if do |item|
-    item.include?(".svn") || item.include?("rdoc")
-  end
-#  s.files << FileList['COPYING', 'Rakefile','am.rb','assumed_library_types.rb','rm.rb']
-#  s.require_paths += [".","am","rm"]
-  s.require_path = "."
-  s.has_rdoc = true
-#  s.extra_rdoc_files = ["README"]
-end
-
-
-Rake::GemPackageTask.new(gem_spec) do |pkg|
-  pkg.need_zip = false
-  pkg.need_tar = false
-end
-
-#CLOBBER.include('rdoc')
-#CLEAN.include('lib/*.output', 'log/*.log')
-
-
 
 
Index: /ruby/trunk/models/am.rb
===================================================================
--- /ruby/trunk/models/am.rb	(revision 30)
+++ /ruby/trunk/models/am.rb	(revision 20)
@@ -17,40 +17,13 @@
   module AM
     module Archetype
-      autoload :ARCHETYPE, "am/archetype/archetype.rb"
+      autoload :Archetype, "am/archetype/archetype.rb"
       autoload :Constraint_Model, "am/archetype/constraint_model/archetype_constraint.rb"
       autoload :Ontology, "am/archetype/ontology.rb"
-      
-      module Archetype_Description
-        autoload :ARCHETYPE_DESCRIPTION, "am/archetype/archetype_description/archetype_description.rb"
-      end
-
+      autoload :Archetype_Description, "am/archetype/archetype_description/archetype_description.rb"
       module Constraint_Model
-        autoload :ARCHETYPE_CONSTRAINT, "am/archetype/constraint_model/archetype_constraint.rb"
+        autoload :Assertion, "am/archetype/constraint_model/assertion.rb"
         autoload :Primitive, "am/archetype/constraint_model/primitive.rb"
       end #end of ConstraintModel
-
-      module Assertion
-        autoload :ASSERTION, "am/archetype/constraint_model/assertion.rb"
-      end
-
     end # of Archetype
-
-    module OpenEHR_Profile
-      module Data_Types
-        module Basic
-          autoload :C_DV_STATE, "am/openehr_profile/data_types/basic.rb"
-        end
-
-        module Text
-          autoload :C_CODE_PHASE, "am/openehr_profile/data_types/text.rb"
-        end
-
-        module Quantity
-          autoload :C_DV_QUANTITY, "am/openehr_profile/data_types/quantity.rb"
-          autoload :C_DV_ORDINAL, "am/openehr_profile/data_types/quantity.rb"
-          autoload :C_QUANTITY_ITEM, "am/openehr_profile/data_types/quantity.rb"
-        end
-      end
-    end
   end # of AM
 end # of OpenEHR
